"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lbc = void 0;
const react_1 = require("@chakra-ui/react");
const react_2 = require("@strata-foundation/react");
const react_3 = __importDefault(require("react"));
const hooks_1 = require("../../hooks");
const BondingPlot_1 = require("./BondingPlot");
const LbcInfo_1 = require("./LbcInfo");
const LbcStatus_1 = require("./LbcStatus");
const TransactionHistory_1 = require("./TransactionHistory");
const selectedProps = {
    borderBottom: "3px solid #F07733",
    fontWeight: "semibold",
};
function Lbc({ id, onConnectWallet, onSuccess, }) {
    const { tokenBonding } = (0, react_2.useTokenSwapFromId)(id);
    const { price } = (0, hooks_1.useLivePrice)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const bg = (0, react_1.useColorModeValue)("white", "black.300");
    return (react_3.default.createElement(react_1.Tabs, { variant: "unstyled", isLazy: true },
        react_3.default.createElement(react_1.TabList, { borderBottom: "none" },
            react_3.default.createElement(react_1.Tab, { _selected: selectedProps, fontWeight: "normal" }, "Swap"),
            react_3.default.createElement(react_1.Tab, { _selected: selectedProps, fontWeight: "normal" }, "Transactions")),
        react_3.default.createElement(react_1.TabPanels, null,
            react_3.default.createElement(react_1.TabPanel, { p: 0, pt: 4 },
                react_3.default.createElement(LbcStatus_1.LbcStatus, { tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey }),
                react_3.default.createElement(react_1.Box, { zIndex: 1, shadow: "xl", rounded: "lg", p: "16px", minH: "300px", bg: bg }, typeof window !== "undefined" && (react_3.default.createElement(react_1.VStack, { align: "stretch", spacing: 8 },
                    react_3.default.createElement(LbcInfo_1.LbcInfo, { price: price, id: id, useTokenOfferingCurve: true }),
                    react_3.default.createElement(react_2.MemodSwap, { onSuccess: onSuccess, onConnectWallet: onConnectWallet, id: id }))))),
            react_3.default.createElement(react_1.TabPanel, { p: 0, pt: 4 },
                react_3.default.createElement(react_1.Box, { zIndex: 1, shadow: "xl", rounded: "lg", p: "16px", pb: "29px", minH: "300px", bg: bg }, typeof window != "undefined" && (react_3.default.createElement(react_1.VStack, { align: "stretch", spacing: 8 },
                    react_3.default.createElement(BondingPlot_1.BondingPlot, { tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey }),
                    react_3.default.createElement(TransactionHistory_1.TransactionHistory, { tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey }))))))));
}
exports.Lbc = Lbc;
//# sourceMappingURL=Lbc.js.map