"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CandyMachineInfo = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@chakra-ui/react");
const spl_token_1 = require("@solana/spl-token");
const react_3 = require("@strata-foundation/react");
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
const LbcInfo_1 = require("../LbcInfo");
const CandyMachineInfo = ({ candyMachine, itemsRemaining, isWhitelistUser, discountPrice }) => {
    const { metadata, loading: loadingMeta } = (0, react_3.useMetaplexTokenMetadata)(candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.tokenMint);
    const ticker = loadingMeta ? "" : (metadata === null || metadata === void 0 ? void 0 : metadata.data.symbol) || "SOL";
    const targetMint = (0, react_3.useMint)((candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.tokenMint) || spl_token_1.NATIVE_MINT);
    return (react_1.default.createElement(react_2.HStack, { spacing: 2, justify: "stretch" },
        react_1.default.createElement(LbcInfo_1.BlackBox, { w: "full" },
            react_1.default.createElement(react_2.VStack, { spacing: 0, align: "left" },
                react_1.default.createElement(react_2.Text, { fontSize: "sm" }, isWhitelistUser && discountPrice ? "Discount Price" : "Price"),
                react_1.default.createElement(LbcInfo_1.BigText, null, isWhitelistUser && discountPrice
                    ? `${targetMint && discountPrice
                        ? (0, spl_token_bonding_1.toNumber)(discountPrice, targetMint)
                        : ""} ${ticker}`
                    : candyMachine
                        ? `${targetMint && (candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.price)
                            ? (0, spl_token_bonding_1.toNumber)((discountPrice || candyMachine.price), targetMint)
                            : ""} ${ticker}`
                        : ""))),
        react_1.default.createElement(LbcInfo_1.BlackBox, { w: "full" },
            react_1.default.createElement(react_2.VStack, { spacing: 0, align: "left" },
                react_1.default.createElement(react_2.Text, { fontSize: "sm" }, "Remaining"),
                react_1.default.createElement(LbcInfo_1.BigText, null, itemsRemaining)))));
};
exports.CandyMachineInfo = CandyMachineInfo;
//# sourceMappingURL=CandyMachineInfo.js.map