"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCandyMachine = exports.CANDY_MACHINE_PROGRAM = void 0;
const anchor_17_1 = require("anchor-17");
const web3_js_1 = require("@solana/web3.js");
const react_1 = require("@strata-foundation/react");
const react_async_hook_1 = require("react-async-hook");
exports.CANDY_MACHINE_PROGRAM = new web3_js_1.PublicKey("cndy3Z4yapfJBmL3ShUp5exZKqR3z33thTzeNMm2gRZ");
function getCoder(provider) {
    return __awaiter(this, void 0, void 0, function* () {
        if (provider) {
            const idl = yield anchor_17_1.Program.fetchIdl(exports.CANDY_MACHINE_PROGRAM, 
            // @ts-ignore
            provider);
            const program = new anchor_17_1.Program(idl, exports.CANDY_MACHINE_PROGRAM, 
            // @ts-ignore
            provider);
            return (pubkey, account) => {
                const coded = program.coder.accounts.decode("CandyMachine", account.data);
                const cndy = Object.assign(Object.assign(Object.assign({}, coded), coded.data), { publicKey: pubkey, program: program, treasury: coded.wallet });
                cndy.maxSupply = cndy.maxSupply.toNumber();
                cndy.itemsRedeemed = cndy.itemsRedeemed.toNumber();
                cndy.itemsAvailable = cndy.itemsAvailable.toNumber();
                cndy.itemsRemaining = cndy.itemsAvailable - cndy.itemsRedeemed;
                return cndy;
            };
        }
    });
}
const useCandyMachine = (candyMachineId) => {
    const { provider } = (0, react_1.useProvider)();
    const { result: coder, error } = (0, react_async_hook_1.useAsync)(getCoder, [provider]);
    if (error) {
        console.error(error);
    }
    return (0, react_1.useAccount)(candyMachineId, coder);
};
exports.useCandyMachine = useCandyMachine;
//# sourceMappingURL=useCandyMachine.js.map